/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.smartapplication.heartbeat.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.smartapplication.heartbeat.entity.DeviceHeartbeat;
import org.springblade.smartapplication.heartbeat.service.IDeviceHeartbeatService;
import org.springblade.smartapplication.heartbeat.vo.DeviceHeartbeatVO;
import org.springblade.smartapplication.heartbeat.vo.HeartBeatEchartVO;
import org.springblade.smartapplication.heartbeat.wrapper.DeviceHeartbeatWrapper;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2020-12-15
 */
@RestController
@AllArgsConstructor
@RequestMapping("deviceheartbeat/deviceheartbeat")
@Api(value = "", tags = "接口")
public class DeviceHeartbeatController extends BladeController {

	private IDeviceHeartbeatService deviceHeartbeatService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入deviceHeartbeat")
	public R<DeviceHeartbeatVO> detail(DeviceHeartbeat deviceHeartbeat) {
		DeviceHeartbeat detail = deviceHeartbeatService.getOne(Condition.getQueryWrapper(deviceHeartbeat));
		return R.data(DeviceHeartbeatWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入deviceHeartbeat")
	public R<IPage<DeviceHeartbeatVO>> list(DeviceHeartbeat deviceHeartbeat, Query query) {
		IPage<DeviceHeartbeat> pages = deviceHeartbeatService.page(Condition.getPage(query), Condition.getQueryWrapper(deviceHeartbeat));
		return R.data(DeviceHeartbeatWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入deviceHeartbeat")
	public R<IPage<DeviceHeartbeatVO>> page(DeviceHeartbeatVO deviceHeartbeat, Query query) {
		IPage<DeviceHeartbeatVO> pages = deviceHeartbeatService.selectDeviceHeartbeatPage(Condition.getPage(query), deviceHeartbeat);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入deviceHeartbeat")
	public R save(@Valid @RequestBody DeviceHeartbeat deviceHeartbeat) {
		return R.status(deviceHeartbeatService.save(deviceHeartbeat));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入deviceHeartbeat")
	public R update(@Valid @RequestBody DeviceHeartbeat deviceHeartbeat) {
		return R.status(deviceHeartbeatService.updateById(deviceHeartbeat));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入deviceHeartbeat")
	public R submit(@Valid @RequestBody DeviceHeartbeat deviceHeartbeat) {
		return R.status(deviceHeartbeatService.saveOrUpdate(deviceHeartbeat));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(deviceHeartbeatService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 *
	 */
	@GetMapping("/getRecordByTab")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "获取Echart返回的数据集合", notes = "传入ids")
	public R<HeartBeatEchartVO> getRecordByTab(@RequestParam String tab,@RequestParam String imei) {
		HeartBeatEchartVO heartBeatEchartVO = new HeartBeatEchartVO();
		QueryWrapper<DeviceHeartbeat> timeQueryWrapper = new QueryWrapper<>();
		 timeQueryWrapper.select("create_time").orderByAsc("create_time").eq("imei",imei);
		List<Object> dateTimeList = deviceHeartbeatService.getBaseMapper().selectObjs(timeQueryWrapper);

		QueryWrapper<DeviceHeartbeat> dataQueryWrapper = new QueryWrapper<>();

		if(tab.equals("battery")){
			dataQueryWrapper.select("battery").orderByAsc("create_time").eq("imei",imei);
		}else if(tab.equals("concentration")){
			dataQueryWrapper.select("concentration").orderByAsc("create_time").eq("imei",imei);
		}else if(tab.equals("temperature")){
			dataQueryWrapper.select("temperature").orderByAsc("create_time").eq("imei",imei);
		}
		List<Object> dataList1 = deviceHeartbeatService.getBaseMapper().selectObjs(dataQueryWrapper);
		List<Integer> dataList = new ArrayList<>();
		for (int i =0;i<dataList1.size();i++){
		dataList.add(Integer.valueOf(dataList1.get(i).toString()));
		}
		heartBeatEchartVO.setDateTimeList(dateTimeList);
		heartBeatEchartVO.setDataList(dataList);
		return R.data(heartBeatEchartVO);
	}


}
